<?php
// +-----------------------------------------------------------------------+
// | PhpWebGallery - a PHP based picture gallery                           |
// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
// | Copyright (C) 2003-2006 PhpWebGallery Team - http://phpwebgallery.net |
// | Copyright (C) 2006 Ruben ARNAUD - team@phpwebgallery.net              |
// +-----------------------------------------------------------------------+
// | last modifier : $Author: rub $
// | revision      : $Revision: 1.0.2.0 $
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// | include                                                               |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die ("Hacking attempt!");
}

include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
include_once(PHPWG_ROOT_PATH.'include/common.inc.php');

// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
check_status(ACCESS_ADMINISTRATOR);

// +-----------------------------------------------------------------------+
// | Main                                                                  |
// +-----------------------------------------------------------------------+
/**
 * returns an array containing sub-directories
 * recursive by default
 *
 * directories nammed ".svn" are omitted
 *
 * @param string $path
 * @param bool $recursive
 * @return array
 */
function get_add_index_directories($path, $recursive = true)
{
  $dirs = array();

  if (is_dir($path))
  {
    if ($contents = opendir($path))
    {
      while (($node = readdir($contents)) !== false)
      {
        if (
            is_dir($path.'/'.$node)
            and $node != '.'
            and $node != '..'
            and $node != '.svn'
           )
        {
          array_push($dirs, $path.'/'.$node);
          if ($recursive)
          {
            $dirs = array_merge($dirs, get_add_index_directories($path.'/'.$node));
          }
        }
      }
    }
  }

  return $dirs;
}

// +-----------------------------------------------------------------------+
// | Main                                                                  |
// +-----------------------------------------------------------------------+
$index_file_src=PHPWG_ROOT_PATH.'include/index.php';
//$index_file_src=PHPWG_ROOT_PATH.'galleries/index.php';
$overwrite_file=isset($_GET['overwrite']);

$count_copy = 0;
$count_skip = 0;
$count_error = 0;

if (@file_exists($index_file_src))
{
  $query = '
select
  galleries_url
from
  '.SITES_TABLE.'
order by
 id';

  $result = pwg_query($query);

  if (mysql_num_rows($result) > 0)
  {
    while (list($galleries_url) = mysql_fetch_row($result))
    {
      if (!url_is_remote($galleries_url))
      {
        //echo $galleries_url.'<BR>';
        foreach (get_add_index_directories($galleries_url) as $dir_galleries)
        {
          $file_dest = $dir_galleries.'/index.php';
          if ($overwrite_file or !@file_exists($file_dest))
          {
            if (copy($index_file_src, $file_dest))
            {
              array_push($page['infos'], sprintf('%s copied', $file_dest));
              $count_copy++;
            }
            else
            {
              array_push($page['errors'], sprintf('%s not copied', $file_dest));
              $count_error++;
            }
          }
          else
          {
            $count_skip++;
          }
        }
      }
    }
  }

  if ($count_copy != 0)
  {
    array_push($page['infos'], sprintf('%d files copied', $count_copy));
  }
  if ($count_skip != 0)
  {
    array_push($page['infos'], sprintf('%d files skipping', $count_skip));
  }
  if ($count_error != 0)
  {
    array_push($page['errors'], sprintf('%d files not copied', $count_error));
  }
}
else
{
  array_push($page['errors'], 'File Source '.$index_file_src.' don\'t esist, cannot duplicate this file');
}

?>